<template>
  <div class="wp-12 wp-layout wp-layout--no-pad wp-layout--form">
    <div class="wp-12 wp-layout wp-layout--no-pad">
      <wp-input class="wp-12" type="text" v-model="gradeChangeGroup.text"
        label="Причина" placeholder="Введите причину"/>
      <wp-input class="wp-12" type="autocomplete" v-model="gradeChangeGroup.user_id"
        label="Пользователь" placeholder="Начните ввод для поиска" :items="membersForSelect"/>
      <div class="wp-12 wp-layout wp-layout--no-pad"
        v-for="gradeChange in gradeChangeGroup.grade_changes" :key="gradeChange.category">
        <wp-input class="wp-6" type="autocomplete" v-model="gradeChange.category"
          label="Категория" placeholder="Начните ввод для поиска" :items="allowedCategories"/>
        <wp-input class="wp-6" type="text" v-model.number="gradeChange.change"
          label="Изменение" placeholder="Введите изменение"/>
      </div>
      <div class="wp-12 wp-layout wp-layout--no-pad"
        v-if="categoriesForSelect.length > 0">
        <wp-input class="wp-6" type="autocomplete" v-model="category_id"
          label="Категория" placeholder="Начните ввод для поиска" :items="categoriesForSelect"
          @select="addGradeChange"/>
        <wp-input class="wp-6" type="text" v-model.number="change"
          label="Изменение" placeholder="Введите изменение"/>
      </div>
    </div>
    <div class="wp-12 wp-layout wp-layout--no-pad">
      <button class="wp-button wp-button--margin-right" @click="submit">
        Сохранить изменения
      </button>
      <button class="wp-button wp-button--cancel" @click="$emit('close')">
        Отменить
      </button>
    </div>
  </div>
</template>

<script>
import { mapActions, mapState, mapGetters } from 'vuex';

import { IsAccessAllowed } from '@/store/session/actions';
import { PermissionsTypes } from '@/shared';

import WpInput from '@/components/WpInput.vue';

export default {
  name: 'IssuedGradeChange',
  components: {
    WpInput,
  },
  data() {
    return {
      category_id: undefined,
      change: 0,
      gradeChangeGroup: {
        user_id: undefined,
        text: '',
        grade_changes: [],
      },
    };
  },
  computed: {
    ...mapState('session', ['permissions', 'selectedOrganization']),
    ...mapState('organization', ['members', 'categories']),
    ...mapGetters('session', ['isUserAdmin']),
    ...mapGetters('organization', ['memberByID', 'categoryByID']),
    isEditing() {
      return !!this.$props.data;
    },
    allowedCategories() {
      const result = [];
      this.categories.forEach((category) => {
        const requiredPermissions = [{
          organization: this.selectedOrganization,
          type: PermissionsTypes.Grades,
          resource: category.id,
          crud: { update: true },
        }];
        if (IsAccessAllowed(this.permissions, requiredPermissions, this.isUserAdmin)) {
          result.push({
            prop: category.id,
            text: category.name,
          });
        }
      });
      return result;
    },
    categoriesForSelect() {
      return this.allowedCategories.filter(category => !this.gradeChangeGroup.grade_changes.find(
        gradeChange => gradeChange.category === category.prop,
      ));
    },
    membersForSelect() {
      return this.members.map(member => ({
        prop: member.id,
        text: member.email,
      }));
    },
  },
  methods: {
    ...mapActions('user', [
      'createGradeChange',
    ]),
    addGradeChange(selectedItem) {
      if (selectedItem) {
        this.gradeChangeGroup.grade_changes.push(
          {
            category: this.category_id,
            change: this.change,
          },
        );
        this.category_id = undefined;
        this.change = 0;
      }
    },
    async submit() {
      try {
        await this.createGradeChange(this.gradeChangeGroup);
        this.$toasted.success('Балл изменен');
        this.$emit('close');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
  },
};
</script>

<style></style>
